/*
 * File:   Id.hpp
 *
 * Author: ABSEHER Michael (abseher@dbai.tuwien.ac.at)
 *
 * Copyright 2015-2017, Michael Abseher
 *    E-Mail: <abseher@dbai.tuwien.ac.at>
 *
 * This file is part of htd.
 *
 * htd is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * htd is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
 * License for more details.

 * You should have received a copy of the GNU General Public License
 * along with htd.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef HTD_HTD_ID_HPP
#define HTD_HTD_ID_HPP

#include <htd/PreprocessorDefinitions.hpp>

#include <cstdlib>
#include <cstdint>

namespace htd
{
    /**
     *  Datatype for IDs.
     */
    typedef std::uint_least32_t id_t;

    /**
     *  Structure containing default values for special identifiers.
     */
    struct HTD_API Id
    {
        public:
            /**
             *  The first allowed ID.
             */
            static const htd::id_t FIRST = 1;

            /**
             *  The ID of unknown or undefined artifacts.
             */
            static const htd::id_t UNKNOWN = 0;

        private:
            Id(void);
    };
}

#endif /* HTD_HTD_ID_HPP */
