/* 
 * File:   PreprocessorDefinitions.hpp
 * 
 * Author: ABSEHER Michael (abseher@dbai.tuwien.ac.at)
 * 
 * Copyright 2015-2017, Michael Abseher
 *    E-Mail: <abseher@dbai.tuwien.ac.at>
 * 
 * This file is part of htd.
 * 
 * htd is free software: you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free 
 * Software Foundation, either version 3 of the License, or (at your 
 * option) any later version.
 * 
 * htd is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public 
 * License for more details.

 * You should have received a copy of the GNU General Public License
 * along with htd.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef HTD_IO_PREPROCESSORDEFINITIONS_HPP
#define HTD_IO_PREPROCESSORDEFINITIONS_HPP

#include <htd/CompilerDetection.hpp>

#include <cassert>

/* #undef HTD_IO_SHARED_LIBRARY */

#if HTD_COMPILER_IS_MSVC == 1
    #define HTD_IO_SYMBOL_EXPORT __declspec(dllexport)
    #define HTD_IO_SYMBOL_IMPORT __declspec(dllimport)
    #define HTD_IO_LOCAL_SYMBOL
#else
    #ifdef HTD_IO_SHARED_LIBRARY
        #if HTD_COMPILER_IS_GNU == 1 || HTD_COMPILER_IS_Clang == 1 || HTD_COMPILER_IS_AppleClang == 1
            #define HTD_IO_SYMBOL_EXPORT __attribute__ ((visibility ("default")))
            #define HTD_IO_SYMBOL_IMPORT __attribute__ ((visibility ("default")))
            #define HTD_IO_LOCAL_SYMBOL  __attribute__ ((visibility ("hidden")))
        #else
            #define HTD_IO_SYMBOL_EXPORT
            #define HTD_IO_SYMBOL_IMPORT
            #define HTD_IO_LOCAL_SYMBOL
        #endif
    #else
        #define HTD_IO_SYMBOL_EXPORT
        #define HTD_IO_SYMBOL_IMPORT
        #define HTD_IO_LOCAL_SYMBOL
    #endif
#endif

#ifdef HTD_IO_SHARED_LIBRARY
    #ifdef htd_io_EXPORTS
        #define HTD_IO_API HTD_SYMBOL_EXPORT
    #else
        #define HTD_IO_API HTD_SYMBOL_IMPORT
    #endif
    #define HTD_IO_LOCAL HTD_LOCAL_SYMBOL
#else
    #define HTD_IO_API
    #define HTD_IO_LOCAL
#endif

#endif /* HTD_IO_PREPROCESSORDEFINITIONS_HPP */
